#include <windows.h>
#include "win043.h"

/* Declaracin del procedimiento de ventana */
LRESULT CALLBACK WindowProcedure(HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */
    char titulo[64];

    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon (hThisInstance, "icono");
    wincl.hIconSm = LoadIcon (hThisInstance, "icono");
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = "menu";
    wincl.cbClsExtra = 0;    /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;    /* clase o la ventana */
    /* Usar el color de fondo por defecto para es escritorio */
    wincl.hbrBackground =  GetSysColorBrush(COLOR_BACKGROUND); //GetStockObject(WHITE_BRUSH);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    LoadString(hThisInstance, ID_TITULO, titulo, 64);

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           titulo,              /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           500,
           450,
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
    }

    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/* Esta funcin es llamada por la funcin del API DispatchMessage() */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    static HINSTANCE hInstance;
    MENUITEMINFO infoMenu;
    char mensaje[64];
    char titulo[64];

    switch (msg)                  /* manipulador del mensaje */
    {
        case WM_CREATE:
           hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
           CheckMenuRadioItem(GetMenu(hwnd),CM_INHIBIR, CM_ACTIVAR, CM_ACTIVAR, MF_BYCOMMAND);
           break;
        case WM_COMMAND:
           switch(LOWORD(wParam)) {
             case CM_INHIBIR:
                EnableMenuItem(GetMenu(hwnd),CM_OPCION, MF_DISABLED | MF_BYCOMMAND);
                CheckMenuRadioItem(GetMenu(hwnd),CM_INHIBIR, CM_ACTIVAR, CM_INHIBIR, MF_BYCOMMAND);
                break;
             case CM_OSCURECER:
                EnableMenuItem(GetMenu(hwnd),CM_OPCION, MF_GRAYED | MF_BYCOMMAND);
                CheckMenuRadioItem(GetMenu(hwnd),CM_INHIBIR, CM_ACTIVAR, CM_OSCURECER, MF_BYCOMMAND);
                break;
             case CM_ACTIVAR:
//                EnableMenuItem(GetMenu(hwnd),CM_OPCION, MF_ENABLED | MF_BYCOMMAND);
                infoMenu.cbSize = sizeof(MENUITEMINFO);
                infoMenu.fMask = MIIM_STATE;
                infoMenu.fState = MFS_ENABLED;
                SetMenuItemInfo(GetMenu(hwnd), CM_OPCION, FALSE, &infoMenu);
                CheckMenuRadioItem(GetMenu(hwnd),CM_INHIBIR, CM_ACTIVAR, CM_ACTIVAR, MF_BYCOMMAND);
                break;
             case CM_OPCION:
                LoadString(hInstance, ID_TITULO, titulo, 64);
                LoadString(hInstance, ID_MENSAJE, mensaje, 64);
                MessageBox(hwnd, mensaje, titulo, MB_OK);
                break;
           }
           break;
        case WM_DESTROY:
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}


